# Модули Angie WASM

## Введение

[Angie](https://angie.software/angie/) — это эффективный, мощный и масштабируемый веб-сервер,
созданный как форк **nginx** и призванный служить его полноценной заменой.
Это позволяет использовать существующие настройки без серьезных изменений в структуре модулей или конфигурации.

Этот репозиторий содержит исходный код и документацию для нескольких модулей, реализующих техническую предварительную версию поддержки WASM для Angie.

## Основные модули

Данная коллекция включает следующие основные модули, упакованные и опубликованные в наших [официальных репозиториях](https://angie.software/angie/docs/installation/):

- **ngx_wasm_module**: Реализует базовую функциональность WASM в Angie.
- **ngx_wasr_module**: Интегрируется с [WebAssembly Micro Runtime](https://github.com/bytecodealliance/wasm-micro-runtime).
- **ngx_wasmtime_module**: Интегрируется с [Wasmtime](https://wasmtime.dev/).

 ## HTTP-модули

- **ngx_http_host_module**: Обеспечивает HTTP-функции для WASM, включая несколько директив и API для работы с HTTP.

Документация по этим модулям доступна на официальном сайте:
https://angie.software/angie/docs/configuration/modules/#wasm-modules

Для устранения неполадок и обратной связи обратитесь по ссылке:
https://angie.software/angie/docs/troubleshooting/

## См. также

- [Angie WASM SDK](https://git.angie.software/web-server/angie-wasm-sdk/): Предоставляет определения интерфейсов и библиотеки для создания WASM-модулей для Angie с использованием высокоуровневых абстракций.

- [Примеры модулей WASM](https://git.angie.software/web-server/angie-wasm-examples/): Примеры на C и Rust, демонстрирующие способы написания модулей WASM для Angie с использованием Angie WASM SDK.
