// Generated by `wit-bindgen` 0.26.0. DO NOT EDIT!
#ifndef __BINDINGS_NGX_WASI_CALL_ENV_H
#define __BINDINGS_NGX_WASI_CALL_ENV_H
#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stdbool.h>

typedef struct ngx_wasi_call_env_string_t {
  uint8_t*ptr;
  size_t len;
} ngx_wasi_call_env_string_t;

// Enum defining standard file descriptors used for input, output,
// error logging, and general application logs. These constants
// help streamline operations involving system-level I/O.
typedef uint8_t ngx_wasi_types_fds_t;

#define NGX_WASI_TYPES_FDS_STDIN 0
#define NGX_WASI_TYPES_FDS_STDOUT 1
#define NGX_WASI_TYPES_FDS_STDERR 2
#define NGX_WASI_TYPES_FDS_LOG 3

typedef struct ngx_wasi_types_bytes_array_t {
  uint8_t   *ptr;
  size_t len;
} ngx_wasi_types_bytes_array_t;

typedef ngx_wasi_call_env_string_t ngx_wasi_types_str_t;

typedef struct ngx_wasi_types_str_array_t {
  ngx_wasi_types_str_t   *ptr;
  size_t len;
} ngx_wasi_types_str_array_t;

typedef struct ngx_wasi_types_kv_t {
  ngx_wasi_types_str_t   key;
  ngx_wasi_types_str_t   value;
} ngx_wasi_types_kv_t;

typedef struct ngx_wasi_types_kv_array_t {
  ngx_wasi_types_kv_t   *ptr;
  size_t len;
} ngx_wasi_types_kv_array_t;

typedef ngx_wasi_types_str_t ngx_wasi_app_str_t;

typedef ngx_wasi_types_str_array_t ngx_wasi_app_str_array_t;

// Represents the application state.
typedef struct ngx_wasi_app_state_t {
  uint32_t   internal;
  // Internal application state identifier.
  uint32_t   ctx;
  // Context identifier for the application.
  int32_t   log;
  // Log descriptor for application logging.
  ngx_wasi_app_str_array_t   argv;
} ngx_wasi_app_state_t;

typedef ngx_wasi_app_state_t ngx_wasi_call_state_t;

// Properties.
typedef uint8_t ngx_wasi_call_prop_t;

#define NGX_WASI_CALL_PROP_STATE 0
// Operate on the state pointer.
#define NGX_WASI_CALL_PROP_RES 1

// Container for function results.
typedef struct ngx_wasi_call_res_t {
  uint8_t   *ptr;
  size_t len;
} ngx_wasi_call_res_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_call_state_t ok;
    int32_t err;
  } val;
} ngx_wasi_call_result_state_s32_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_call_res_t ok;
  } val;
} ngx_wasi_call_result_res_void_t;

// Imported Functions from `ngx:wasi/call`
// Initializes or restores the application state, optionally retrieves the argv array.
extern bool ngx_wasi_call_init_app(int32_t call_env, bool argv, ngx_wasi_call_state_t *ret, int32_t *err);
// Allocates memory for the result from the library pool.
extern bool ngx_wasi_call_alloc_result(ngx_wasi_call_state_t *app, uint32_t len, ngx_wasi_call_res_t *ret);
// Passes non-integer function results to the host.
// 
// Input:
// call-env: Descriptor of the call environment.
// buf: Pointer to the buffer with bytes.
// len: Buffer length.
// 
// Output:
// Return code: Negative on error.
// 
// If result memory was obtained from the library pool, no free() is needed.
// If result memory was allocated by other means, the app can free() it.
extern int32_t ngx_wasi_call_save_result(ngx_wasi_call_state_t *app, ngx_wasi_call_res_t *buf);

#ifdef __cplusplus
}
#endif
#endif
