// Generated by `wit-bindgen` 0.26.0. DO NOT EDIT!
#ifndef __BINDINGS_NGX_WASI_HTTP_REQUEST_H
#define __BINDINGS_NGX_WASI_HTTP_REQUEST_H
#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stdbool.h>

typedef struct ngx_wasi_http_request_string_t {
  uint8_t*ptr;
  size_t len;
} ngx_wasi_http_request_string_t;

// Enum defining standard file descriptors used for input, output,
// error logging, and general application logs. These constants
// help streamline operations involving system-level I/O.
typedef uint8_t ngx_wasi_types_fds_t;

#define NGX_WASI_TYPES_FDS_STDIN 0
#define NGX_WASI_TYPES_FDS_STDOUT 1
#define NGX_WASI_TYPES_FDS_STDERR 2
#define NGX_WASI_TYPES_FDS_LOG 3

typedef struct ngx_wasi_types_bytes_array_t {
  uint8_t   *ptr;
  size_t len;
} ngx_wasi_types_bytes_array_t;

typedef ngx_wasi_http_request_string_t ngx_wasi_types_str_t;

typedef struct ngx_wasi_types_str_array_t {
  ngx_wasi_types_str_t   *ptr;
  size_t len;
} ngx_wasi_types_str_array_t;

typedef struct ngx_wasi_types_kv_t {
  ngx_wasi_types_str_t   key;
  ngx_wasi_types_str_t   value;
} ngx_wasi_types_kv_t;

typedef struct ngx_wasi_types_kv_array_t {
  ngx_wasi_types_kv_t   *ptr;
  size_t len;
} ngx_wasi_types_kv_array_t;

typedef ngx_wasi_types_str_t ngx_wasi_http_request_str_t;

typedef ngx_wasi_types_str_array_t ngx_wasi_http_request_str_array_t;

typedef ngx_wasi_types_bytes_array_t ngx_wasi_http_request_bytes_array_t;

// This interface is not yet complete and may change.
// All functions operate on an opaque request pointer provided by
// the core HTTP component.
// Properties used by the low-level interface.
typedef uint8_t ngx_wasi_http_request_props_t;

// Input
#define NGX_WASI_HTTP_REQUEST_PROPS_METHOD 0
#define NGX_WASI_HTTP_REQUEST_PROPS_SCHEMA 1
#define NGX_WASI_HTTP_REQUEST_PROPS_VERSION 2
#define NGX_WASI_HTTP_REQUEST_PROPS_URI 3
#define NGX_WASI_HTTP_REQUEST_PROPS_REMOTE_ADDR 4
#define NGX_WASI_HTTP_REQUEST_PROPS_DISCARD_BODY 5
#define NGX_WASI_HTTP_REQUEST_PROPS_VAR 6
// Output
#define NGX_WASI_HTTP_REQUEST_PROPS_STATUS 7
#define NGX_WASI_HTTP_REQUEST_PROPS_CONTENT_LENGTH 8
#define NGX_WASI_HTTP_REQUEST_PROPS_RANGES 9
#define NGX_WASI_HTTP_REQUEST_PROPS_HEADER_ONLY 10
#define NGX_WASI_HTTP_REQUEST_PROPS_REJECT_MSG 11

typedef uint8_t ngx_wasi_http_request_schema_t;

#define NGX_WASI_HTTP_REQUEST_SCHEMA_HTTP 0
#define NGX_WASI_HTTP_REQUEST_SCHEMA_HTTPS 1
#define NGX_WASI_HTTP_REQUEST_SCHEMA_UNKNOWN 2

typedef uint8_t ngx_wasi_http_request_method_t;

#define NGX_WASI_HTTP_REQUEST_METHOD_UNKNOWN 0
#define NGX_WASI_HTTP_REQUEST_METHOD_GET 1
#define NGX_WASI_HTTP_REQUEST_METHOD_HEAD 2
#define NGX_WASI_HTTP_REQUEST_METHOD_POST 3
#define NGX_WASI_HTTP_REQUEST_METHOD_PUT 4
#define NGX_WASI_HTTP_REQUEST_METHOD_DELETE 5
#define NGX_WASI_HTTP_REQUEST_METHOD_MKCOL 6
#define NGX_WASI_HTTP_REQUEST_METHOD_COPY 7
#define NGX_WASI_HTTP_REQUEST_METHOD_MOVE 8
#define NGX_WASI_HTTP_REQUEST_METHOD_OPTIONS 9
#define NGX_WASI_HTTP_REQUEST_METHOD_PROPFIND 10
#define NGX_WASI_HTTP_REQUEST_METHOD_PROPPATCH 11
#define NGX_WASI_HTTP_REQUEST_METHOD_LOCK 12
#define NGX_WASI_HTTP_REQUEST_METHOD_UNLOCK 13
#define NGX_WASI_HTTP_REQUEST_METHOD_PATCH 14
#define NGX_WASI_HTTP_REQUEST_METHOD_TRACE 15
#define NGX_WASI_HTTP_REQUEST_METHOD_CONNECT 16

typedef uint8_t ngx_wasi_http_request_header_ops_t;

#define NGX_WASI_HTTP_REQUEST_HEADER_OPS_SEND 0

typedef uint8_t ngx_wasi_http_request_version_t;

#define NGX_WASI_HTTP_REQUEST_VERSION_UNKNOWN 0
#define NGX_WASI_HTTP_REQUEST_VERSION_V09 1
#define NGX_WASI_HTTP_REQUEST_VERSION_V10 2
#define NGX_WASI_HTTP_REQUEST_VERSION_V11 3
#define NGX_WASI_HTTP_REQUEST_VERSION_V20 4
#define NGX_WASI_HTTP_REQUEST_VERSION_V30 5

typedef struct {
  bool is_err;
  union {
    uint32_t ok;
  } val;
} ngx_wasi_http_request_result_u32_void_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_http_request_method_t ok;
  } val;
} ngx_wasi_http_request_result_method_void_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_http_request_schema_t ok;
  } val;
} ngx_wasi_http_request_result_schema_void_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_http_request_version_t ok;
  } val;
} ngx_wasi_http_request_result_version_void_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_http_request_str_t ok;
  } val;
} ngx_wasi_http_request_result_str_void_t;

typedef struct {
  bool is_err;
  union {
    ngx_wasi_http_request_str_array_t ok;
    int32_t err;
  } val;
} ngx_wasi_http_request_result_str_array_s32_t;

// Imported Functions from `ngx:wasi/http-request`
extern bool ngx_wasi_http_request_init(int32_t rctx, int32_t log, uint32_t *ret);
extern int32_t ngx_wasi_http_request_process(uint32_t req);
// Per-request user context.
extern void ngx_wasi_http_request_set_context(uint32_t req, uint32_t data);
extern uint32_t ngx_wasi_http_request_get_context(uint32_t req);
// Rejects a request with the specified status code and error string.
extern int32_t ngx_wasi_http_request_reject(uint32_t req, uint32_t status, ngx_wasi_http_request_str_t *msg);
// Gets the request log descriptor.
extern int32_t ngx_wasi_http_request_get_log(uint32_t req);
// Getters for various request properties.
extern bool ngx_wasi_http_request_get_method(uint32_t req, ngx_wasi_http_request_method_t *ret);
extern bool ngx_wasi_http_request_get_schema(uint32_t req, ngx_wasi_http_request_schema_t *ret);
extern bool ngx_wasi_http_request_get_version(uint32_t req, ngx_wasi_http_request_version_t *ret);
extern bool ngx_wasi_http_request_get_uri(uint32_t req, ngx_wasi_http_request_str_t *ret);
extern bool ngx_wasi_http_request_get_remote_addr(uint32_t req, ngx_wasi_http_request_str_t *ret);
// Returns the value of the specified variable.
extern bool ngx_wasi_http_request_variable(uint32_t req, ngx_wasi_http_request_str_t *key, ngx_wasi_http_request_str_t *ret);
// Returns a single header or a list of headers with the same name.
extern bool ngx_wasi_http_request_get_header(uint32_t req, ngx_wasi_http_request_str_t *key, ngx_wasi_http_request_str_array_t *ret, int32_t *err);
extern bool ngx_wasi_http_request_get_header_values(uint32_t req, ngx_wasi_http_request_str_t *key, ngx_wasi_http_request_str_array_t *ret, int32_t *err);
// Sets a header (single or multiple values).
extern int32_t ngx_wasi_http_request_set_header(uint32_t req, ngx_wasi_http_request_str_t *key, ngx_wasi_http_request_str_t *value);
extern int32_t ngx_wasi_http_request_set_header_values(uint32_t req, ngx_wasi_http_request_str_t *key, ngx_wasi_http_request_str_array_t *value);
extern int32_t ngx_wasi_http_request_flush_headers(uint32_t req);
// Specifies how to handle the request body: skip (false) or process (true).
extern int32_t ngx_wasi_http_request_handle_body(uint32_t req, uint8_t enabled);
// Reads request body bytes into the provided buffer.
extern int32_t ngx_wasi_http_request_read_body(uint32_t req, ngx_wasi_http_request_bytes_array_t *buf);
// Sets the response status code.
extern int32_t ngx_wasi_http_request_set_status(uint32_t req, uint32_t status);
// Specifies how to handle the response: if it has a body, specify the length.
extern int32_t ngx_wasi_http_request_setup_response(uint32_t req, uint8_t has_body, uint64_t body_len);
// Writes to the response body from the specified buffer.
extern int32_t ngx_wasi_http_request_write_body(uint32_t req, ngx_wasi_http_request_bytes_array_t *buf);
// Completes request handling; the finalize handler will be called.
extern int32_t ngx_wasi_http_request_finalize(uint32_t req);

#ifdef __cplusplus
}
#endif
#endif
