// Generated by `wit-bindgen` 0.26.0. DO NOT EDIT!
#ifndef __BINDINGS_NGX_WASI_SYSCALL_H
#define __BINDINGS_NGX_WASI_SYSCALL_H
#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stdbool.h>

typedef struct ngx_wasi_syscall_string_t {
  uint8_t*ptr;
  size_t len;
} ngx_wasi_syscall_string_t;

// Enum defining standard file descriptors used for input, output,
// error logging, and general application logs. These constants
// help streamline operations involving system-level I/O.
typedef uint8_t ngx_wasi_types_fds_t;

#define NGX_WASI_TYPES_FDS_STDIN 0
#define NGX_WASI_TYPES_FDS_STDOUT 1
#define NGX_WASI_TYPES_FDS_STDERR 2
#define NGX_WASI_TYPES_FDS_LOG 3

typedef struct ngx_wasi_types_bytes_array_t {
  uint8_t   *ptr;
  size_t len;
} ngx_wasi_types_bytes_array_t;

typedef ngx_wasi_syscall_string_t ngx_wasi_types_str_t;

typedef struct ngx_wasi_types_str_array_t {
  ngx_wasi_types_str_t   *ptr;
  size_t len;
} ngx_wasi_types_str_array_t;

typedef struct ngx_wasi_types_kv_t {
  ngx_wasi_types_str_t   key;
  ngx_wasi_types_str_t   value;
} ngx_wasi_types_kv_t;

typedef struct ngx_wasi_types_kv_array_t {
  ngx_wasi_types_kv_t   *ptr;
  size_t len;
} ngx_wasi_types_kv_array_t;

typedef ngx_wasi_types_str_t ngx_wasi_syscall_str_t;

// Imported Functions from `ngx:wasi/syscall`
// All syscalls return:
// On success: NGX_OK (zero) or a positive value (depending on semantics).
// On error: NGX_ERROR, NGX_AGAIN, etc., which are standard nginx return codes (negative).
// 
// Negative codes are expected to be returned to the host as is.
// Returns a descriptor to work with an interface identified by name.
// The ctx is either -1 (unused) or a valid descriptor of some object
// that needs to be passed into open as context.
extern int32_t ngx_wasi_syscall_open(ngx_wasi_syscall_str_t *name, int32_t ctx);
// Performs I/O on the descriptor. Maintains state and returns zero in EOF-like situations.
extern int32_t ngx_wasi_syscall_read(int32_t handle, uint32_t buf, uint32_t len);
extern int32_t ngx_wasi_syscall_write(int32_t handle, uint32_t buf, uint32_t len);
// Sets and gets specific properties. Semantics depend on the interface used.
extern int32_t ngx_wasi_syscall_get(int32_t handle, uint32_t propid, uint32_t buf, uint32_t len);
extern int32_t ngx_wasi_syscall_set(int32_t handle, uint32_t propid, uint32_t val, uint32_t len);
// Closes the descriptor and frees all internal state created by open().
extern int32_t ngx_wasi_syscall_close(int32_t handle);

#ifdef __cplusplus
}
#endif
#endif
